package org.apache.maven.deploy.deployers;

/* ====================================================================
 *   Copyright 2001-2004 The Apache Software Foundation.
 *
 *   Licensed under the Apache License, Version 2.0 (the "License");
 *   you may not use this file except in compliance with the License.
 *   You may obtain a copy of the License at
 *
 *       http://www.apache.org/licenses/LICENSE-2.0
 *
 *   Unless required by applicable law or agreed to in writing, software
 *   distributed under the License is distributed on an "AS IS" BASIS,
 *   WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 *   See the License for the specific language governing permissions and
 *   limitations under the License.
 * ====================================================================
 */

import java.io.FileInputStream;
import java.io.IOException;
import java.io.PrintWriter;

import org.apache.commons.lang.StringUtils;
import org.apache.commons.net.ProtocolCommandEvent;
import org.apache.commons.net.ProtocolCommandListener;
import org.apache.commons.net.ftp.FTP;
import org.apache.commons.net.ftp.FTPClient;
import org.apache.commons.net.ftp.FTPReply;
import org.apache.maven.deploy.RepositoryInfo;
import org.apache.maven.deploy.DeployRequest;
import org.apache.maven.deploy.exceptions.AuthenticationException;
import org.apache.maven.deploy.exceptions.TransferFailedException;

/**
 * An FTP deployer based on the FTPClient in the Commons Net package.
 *
 * Proxy server for FTPClient is not supported:
 * {@link http://nagoya.apache.org/bugzilla/show_bug.cgi?id=18039}
 * 
 * @author <a href="mailto:jason@zenplex.com">Jason van Zyl</a>
 * @author <a href="michal.maczka@dimatics.com">Michal Maczka</a>
 * @version $Id: FtpDeployer.java,v 1.8 2004/03/02 14:59:31 evenisse Exp $
 * 
 * @todo review exception handling
 * 
 * 
 */
public class FtpDeployer extends AbstractDeployer
{
    /** Protocol understandable by this deployer*/
    public final static String PROTOCOL = "ftp://";

    private FTPClient ftp = null;

    /* (non-Javadoc)
     * @see org.apache.maven.deploy.deployers.Deployer#init(org.apache.maven.deploy.HostInfo)
     */
    public void init(RepositoryInfo repoInfo)
        throws AuthenticationException
    {
        String username = repoInfo.getUserName();
        String password = repoInfo.getPassword();
        String host = repoInfo.getHost();

        ftp = new FTPClient();

        if (repoInfo.isDebugOn())
        {
            ftp.addProtocolCommandListener(
                new PrintCommandListener(new PrintWriter(System.out)));
        }
        try
        {
            int reply;
            if (repoInfo.getPort()
                != RepositoryInfo.UNKNOWN_PORT)
            {
                ftp.connect(host, repoInfo.getPort());
            }
            else
            {
                ftp.connect(host);
            }
            System.out.println("Connected to " + host + ".");

            // After connection attempt, you should check the reply code to verify
            // success.
            reply = ftp.getReplyCode();

            if (FTPReply.isPositiveCompletion(reply) == false)
            {
                ftp.disconnect();
                System.err.println();
                throw new AuthenticationException("FTP server refused connection.");
            }
        }
        catch (IOException e)
        {
            if (ftp.isConnected())
            {
                try
                {
                    ftp.disconnect();
                }
                catch (IOException f)
                {
                    // do nothing
                }
            }
            throw new AuthenticationException("Could not connect to server.");
        }

        try
        {
            if (ftp.login(username.trim(), password.trim()) == false)
            {
                throw new AuthenticationException("Cannot login to remote system");
            }

            System.out.println("Remote system is " + ftp.getSystemName());

            // Set to binary mode.
            ftp.setFileType(FTP.BINARY_FILE_TYPE);
            // Use passive mode as default because most of us are
            // behind firewalls these days.
            ftp.enterLocalPassiveMode();
            ftp.changeWorkingDirectory(repoInfo.getBasedir());

        }
        catch (IOException e)
        {
            throw new AuthenticationException("Cannot login to remote system");
        }

    }

    /* (non-Javadoc)
     * @see org.apache.maven.deploy.deployers.Deployer#release()
     */
    public void release()
    {
        if (ftp.isConnected())
        {
            try
            {
                ftp.disconnect();
            }
            catch (IOException e)
            {
                // do nothing
            }
        }

    }

    /**
     * @see Deployer#deploy(DeployRequest)
     */
    public void deploy(DeployRequest request) throws TransferFailedException
    {

        try
        {
            String[] dirs = StringUtils.split(request.dirname(), "/");
            for (int i = 0; i < dirs.length; i++)
            {
                ftp.makeDirectory(dirs[i]);
                ftp.changeWorkingDirectory(dirs[i]);
            }
            ftp.storeFile(
                request.filename(),
                new FileInputStream(request.getSrcFile()));
            for (int i = 0; i < dirs.length; i++)
            {
               ftp.changeWorkingDirectory("..");
            }

        }
        catch (Exception e)
        {
            e.printStackTrace();
            throw new TransferFailedException(e.getMessage());
        }

    }

    /**
     * Description of the Class
     */
    public class PrintCommandListener implements ProtocolCommandListener
    {
        private PrintWriter writer;

        /**
         * Constructor for the PrintCommandListener object
         *
         * @param writer
         */
        public PrintCommandListener(PrintWriter writer)
        {
            this.writer = writer;
        }

        /**
         * Description of the Method
         */
        public void protocolCommandSent(ProtocolCommandEvent event)
        {
            writer.print(event.getMessage());
            writer.flush();
        }

        /**
         * Description of the Method
         */
        public void protocolReplyReceived(ProtocolCommandEvent event)
        {
            writer.print(event.getMessage());
            writer.flush();
        }
    }

}
